
package lib1

model BouncingBall      "modified BB model from OpenModelica tutorial"
  parameter Real initialHeight = 1;
  parameter Real e = 0.7        "coefficient of restitution";
  parameter Real g = 9.81       "gravity acceleration";
  Real h(start = initialHeight) "height of ball";
  Real v                        "velocity of ball";
  Boolean flying(fixed = true, start = true) "true, if ball is flying";
  Real v_new(fixed = true);
equation
  der(v) = if flying then -g else 0;
  der(h) = if flying then v else 0;
  when h <= 0.0 and v <= 0.0 then
    v_new =  -e * pre(v);
    flying = abs(v) > 1e-4;
    reinit(v, if flying then v_new else 0);
  end when;
end BouncingBall;

end lib1;

